/*# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
#                        pour la Sant�)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and
#  abiding by the rules of distribution of free software. You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL-B
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------ */


#include "marUtils.h"

// ----------------------------------------------------------------------------
marUtils::marUtils()
{

}

// ----------------------------------------------------------------------------
marUtils::~marUtils()
{

}
// ----------------------------------------------------------------------------
double marUtils::obtainAverage(std::vector<double> list)
{
	double average = 0;
	for (int i = 0; i < list.size(); i++)
	{
		average += list[i];
	}

	if (list.size() > 0)
	{
		average = average / list.size();
	}

	return average;

}

// ----------------------------------------------------------------------------
double marUtils::obtainStandardDeviation(std::vector<double> list, double average)
{
	double std = 0;

	for(int i = 0; i < list.size(); i++)
	{
		std += pow(list[i] - average,2.0);
	}

	if (list.size() > 0)
	{
		std = sqrt(std/list.size());
	}

	return std;
}
